# Myna Grammars 

A Myna grammar is any JavaScript object that has Myna parsing rules as fields. A Myna parsing rule 
is an object derived from `Myna.Rule`. 

Typically a grammar constructor will register itself with Myna, using the `Myna.registerGrammar()`
function. Registering a grammar, provides a name to each rule, and makes the rules of the grammar 
accesible to other consumers of the Myna module.

The convention used in this library is that each grammar has its own source file which can
be included in a JavaScript file. The grammar constructor is exported in such a way to be 
usable from Node.js.  

## Grammar Utility Functions 

- `Myna.registerGrammar` - applies the name to each rule in the grammar and stores in Myna. 
- `Myna.allGrammarRules` - lists all of the rules for all registered grammars  
- `Myna.grammarNames` - lists the names of all the registered grammar
- `Myna.grammarRules` - this the rules associated with a particular grammar
- `Myna.grammarToString` - returns a string representation of a grammar in a pseduo-PEG notation
- `Myna.astSchemaToString` - returns a string representation of the schema of AST nodes generated by a grammar
